SystemOrganization addCategory: #MailSortingOffice!
SystemOrganization addCategory: 'MailSortingOffice-Core'!
SystemOrganization addCategory: 'MailSortingOffice-Morphic'!

Object subclass: #MailSortingOffice
	instanceVariableNames: 'mailStream pigeonHoles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingOffice-Core'!

!MailSortingOffice commentStamp: 'HwaJong 1/24/2014 01:08' prior: 0!
Letters arrive in the sorting room and are quickly placed into pigeon holes based on destination.!

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:18'!
currentMail
	^mailStream peek! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:15'!
mails: aSequenceableCollection 
	mailStream := ReadStream on: aSequenceableCollection! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:32'!
makePigeonHoles: anInteger 
	| streamSize |
	streamSize := mailStream ifNil: [10] ifNotNil: [(mailStream size / anInteger) ceiling].
	pigeonHoles := anInteger timesCollect: [ WriteStream on: (Array new: streamSize) ]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:29'!
numberOfPigeonHolds
	^pigeonHoles size! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:13'!
pigeonHoleContents
	^pigeonHoles collect: #contents! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:17'!
throughCurrentMailIntoPigeonHoleAtIndex: anInteger 
	[ mailStream atEnd not ] assert.
	(pigeonHoles at: anInteger) nextPut: mailStream next! !

Object subclass: #MailSortingOfficeController
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingOffice-Morphic'!

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:26'!
missionMessage
	^'Sorting things out!!'! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:21'!
model: aMailSortingOffice 
	model := aMailSortingOffice! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:41'!
open
	| q window |
	q := QuickPrototyping for: self.
	window := StandardWindow new.
	window addMorph: (q label: #missionMessage) frame: (0@0 extent: 1@0.1).
	self pigeonHoleNames keysAndValuesDo: [:th :each| window addMorph: each asMorph frame: (((th-1)/self pigeonHoleNames size)@0.1 extent:  (1 / self pigeonHoleNames size)@0.1 )].
	window setLabel: 'Mail Sorting Office'.
	window openInWorld.! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 01:40'!
pigeonHoleNames
	^{'one'. 'two'. 'three'}! !

Object subclass: #PigeonHole
	instanceVariableNames: 'name writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

Object subclass: #PigeonHoleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Morphic'!
